/*============================================================================
//	aPCI8815̒`
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1998/10/21
//
//===========================================================================*/
#if !defined(_APCI8815_H)
#define _APCI8815_H

#ifndef _TYPEDEF_H
	#include "typedef.h"
#endif

#ifndef _APCISRVS_H
	#include "apcisrvs.h"
#endif

#ifndef _APCICTRL_H
	#include "apcictrl.h"
#endif

/*==========================================*/
/*	aPCI-8815 card's relative port address	*/
/*==========================================*/
/* Input Ports */
#define APCI8815_STR_PORT		0		/* STR|[g */
#define APCI8815_CD_PORT		1		/* CD|[g */

#define APCI8815_STR_CVDF		0x0001	/* STR|[g ǂݏo\ */

#define APCI8815_STR_EXTRG		0x0020	/* STR|[g ExTrg ̏ */
#define APCI8815_STR_EXIN0		0x0040	/* STR|[g ExIn0 ̏ */
#define APCI8815_STR_EXIN1		0x0080	/* STR|[g ExIn1 ̏ */


/* Output ports */
#define APCI8815_CTL_PORT		0		/* CTL|[g */
#define APCI8815_TW_PORT		1		/* TW|[g	 */
#define APCI8815_INTC_PORT		2		/* INTC|[g */

#define APCI8815_CTL_RESET		0x0000	/* CTL|[g Zbg	*/
#define APCI8815_CTL_START		0x0001	/* CTL|[g A/DϊX^[g	*/
#define APCI8815_CTL_INT		0x0004	/* CTL|[g ^C}̊荞ݔ	*/
#define APCI8815_CTL_SMP		0x0006	/* CTL|[g ^C}A/Dϊf[^̈TvO	*/
#define APCI8815_CTL_CISW		0x0008	/* CTL|[g `lI[gCNg	*/
#define APCI8815_CTL_EXTSW		0x0010	/* CTL|[g OgK	*/
#define APCI8815_CTL_E0			0x0040	/* CTL|[g ^C}͎g0	*/
#define APCI8815_CTL_E1			0x0080	/* CTL|[g ^C}͎g1	*/

#define APCI8815_INTC_RESET		0x0000	/* INTC|[g Zbg */


/*======================================*/
/* Sampling definition					*/
/*======================================*/

/* Sampling modes */
							/* Start Sampling Transfer CLK	 */
#define APCI8815_MODE_01  1 /* soft	 single	  port	   ---	 */
#define APCI8815_MODE_02  2 /* soft	 single	  port	   EXTRG */
#define APCI8815_MODE_03  3 /* soft	 burst	  port	   timer */
#define APCI8815_MODE_04  4 /* soft	 burst	  port	   EXTRG */

/* Sampling channel range */
#define APCI8815_CH_FIRST	0
#define APCI8815_CH_LAST	15

/* Sampling channel */
#define APCI8815_CH_01		0
#define APCI8815_CH_02		1
#define APCI8815_CH_03		2
#define APCI8815_CH_04		3
#define APCI8815_CH_05		4
#define APCI8815_CH_06		5
#define APCI8815_CH_07		6
#define APCI8815_CH_08		7
#define APCI8815_CH_09		8
#define APCI8815_CH_10		9
#define APCI8815_CH_11		10
#define APCI8815_CH_12		11
#define APCI8815_CH_13		12
#define APCI8815_CH_14		13
#define APCI8815_CH_15		14
#define APCI8815_CH_16		15

/* Sampling timer range */
#define APCI8815_TM_MIN		12LU		/* Minimum */
#define APCI8815_TM_MAX		64000000LU	/* Maximum */

/*==================*/
/*	Miscellaneous	*/
/*==================*/
#define	APCI8815_MAX_SLOTS	16			/* Maximum number of slots */

/*==============*/
/*	Device ID	*/
/*==============*/
#define	APCI8815_BOARD_ID		0x8815	/* pci bus device id */
#define	APCI8815_VENDOR_ID		0x136c	/* pci bus vendor id */
										/* our device id */
#define	APCI8815_DEVICE_ID	( ( DWORD )APCI8815_BOARD_ID\
							| ( ( DWORD )APCI8815_VENDOR_ID << 16 ) )

#endif
