//****************************************************************************
//	apci8815s.pas
//
//	aPCI-8815
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/07/10
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit apci8815s;

interface

uses
	Windows, Messages, SysUtils, Forms, apci8815w;

const
	szTitle = 'Sample';
	sz8815	 = 'aPCI-8815';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 String;
	dwDLLVer,	 dwDrvVer: DWord;
	bResult:	 Boolean;						// 
	wLogSlot:	 Word;							// foCXi[
	ri:				 TAPCI8815RESOURCE;	// \[X
	md:				 TAPCI8815MODE;			// TvO[h
	dwNumData: DWord;
	dwStatus:	 DWord;
	Data:			 TVXDBUFF;
	i:				 Integer;
	dwExIn0,	 dwExIn1, dwExTrg: DWord;
	hWnd:			 THandle;
	InitArg:	DWord;
begin
//---------------------------------------------------------------------------
	// apci8815.dll ̎gp錾
	if Apci8815wDllOpen() = False then
	begin
		ErrorMessage(APCI8815_SLOT_AUTO);
		Exit;			// apci8815.dll ̃[hɎs܂
	end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aPCI-8815 DLL,Driver̃o[Wԍ擾
	if Apci8815wGetVersion(dwDLLVer, dwDrvVer) = False then
	begin
		ErrorMessage(APCI8815_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Driver Version: %08xH',
										 [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aPCI-8815̎gp錾
	wLogSlot := APCI8815_SLOT_AUTO;		// gp̃foCXT܂B
	hWnd		:= 0;
	InitArg := 0;
	bResult := Apci8815wCreate(wLogSlot,	// ꍇA̎̃foCXi[܂B
							hWnd,							// EBhEnhȂ̂NULLZbg܂B
																// EBhEnhZbg΁A
																// e탁bZ[W܂B
							$6401,						// 3ԖڂɃZbgẮAbZ[WID̊
																// ƂȂlłBۂ̃bZ[WID͂̊lɃI
																// tZbg(WM_EOCȂ)̂ƂȂ܂B
							InitArg);

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(APCI8815_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aPCI-8815 Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// \[X擾
	if Apci8815wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
									 'IO Base Address: %04xH-%04xH'#10 +
									 'IRQ: %2d',
										 [sz8815, ri.dwIOPortBase[1],
                      ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1,
											ri.dwIRQRegisters[1]]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// TvO[h̐ݒ
	md.dwChFirst := 0;		// TvOJn`l(0 ` 15)
	md.dwChLast	:= 15;		// TvOI`l(0 ` 15)
	md.cwBuffer := 256;		// obt@TCYi[hPʁj
	md.dwTimer	:= 500;		// ^C}l(35`64000000)
	md.dwMode		:= APCI8815_MODE_03;	// 샂[h(1`4)

	if Apci8815wSetMode(wLogSlot, @md) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('aPCI-8815 Sampling Mode'#10 +
									 'TvOJn`l=%d'#10 +
									 'TvOI`l=%d'#10 +
									 'obt@TCY=%d'#10 +
									 '^C}l=%d'#10 +
									 '샂[h=%d',
									 [md.dwChFirst, md.dwChLast, md.cwBuffer,
										md.dwTimer, md.dwMode]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// TvOJn
	if Apci8815wStartSampling(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aPCI-8815 Sampling Started');

//---------------------------------------------------------------------------
	// TvOEXe[^X̎擾
	if Apci8815wGetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('TvOEXe[^X擾'#10 +
									 'f[^=%d'#10 +
									 'Xe[^X=%d',
									 [dwNumData, dwStatus]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// TvOς݃f[^̎擾
	if dwNumData > 0 then
	begin
		for i:=1 to (APCI8815_CH_MAX)*(APCI8815_BUFF_PCH_MAX-1) do Data[i]:=0;

		if Apci8815wGetData(wLogSlot, dwNumData, @Data) = False then
		begin
			ErrorMessage(wLogSlot);
			Exit;
		end;

    if dwNumData > 99 then dwNumData := 99;	// f[^99ҏW甲悤ɂ

		strbuf := 'TvOς݃f[^擾'#10;
		for i := 1 to dwNumData -1 do
		begin
			strbuf := strbuf + Format('%d:%.xH	', [i, Data[i]]);

			if (i + 1) mod 4 = 0 then	// 4 Ŋ؂
				strbuf := strbuf + #10;
		end;

		ResultMessage(strbuf);
	end;

//---------------------------------------------------------------------------
	// TvO~
	if Apci8815wStopSampling(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aPCI-8815 Sampling Stopped');

//---------------------------------------------------------------------------
	// O͏Ԃ̎擾
	if Apci8815wGetExIn(wLogSlot, dwExIn0, dwExIn1, dwExTrg) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('O͏Ԃ̎擾'#10 +
						'EXIN0̏=%.xH'#10 +
						'EXIN1̏=%.xH'#10 +
						'EXTRG̏=%.xH',
						[dwExIn0, dwExIn1, dwExTrg]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aPCI-8815̎gpJ
	if Apci8815wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aPCI-8815 Closed');

	// apci8815.dll ̎gpJ
	if Apci8815wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// apci8815.dll ̃A[hɎs܂B
	end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Apci8815wGetLastError(wLogSlot);

	case dwRes of
		APCI8815_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aPCI-8815 error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
