Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       apci8815.bas
'
'       aPCI-8815 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

'-----------------------------------------------------------
' Miscellaneous
'-----------------------------------------------------------

Global Const APCI8815_MAX_SLOTS = 16             ' Maximum number of slots

Global Const APCI8815_SLOT_AUTO = &HFFFF         ' default search


'-----------------------------------------------------------
'  Device ID
'-----------------------------------------------------------
Global Const APCI8815_VENDOR_ID = &H136C
Global Const APCI8815_DEVICE_ID = &H8815

'-----------------------------------------------------------
' Error codes
'-----------------------------------------------------------

Global Const APCI8815_ERR_SYSTEM = 5000           ' Windows  GetLastError() R[ĂB
                                                  ' ̃tH_ɃhCoȂ\܂B
Global Const APCI8815_ERR_NO_DEVICE = 5001        ' gp\ȃfoCX܂B
Global Const APCI8815_ERR_IN_USE = 5002           ' w̃foCX͎gpłB
Global Const APCI8815_ERR_INVALID_ARGUMENT = 5003 ' Invalid Argument(s)
Global Const APCI8815_ERR_INVALID_SLOT = 5004     ' Ș_XbgłB
Global Const APCI8815_ERR_NOT_CREATED = 5005      ' foCXNGCgĂ܂B
Global Const APCI8815_ERR_CHANNEL = 5006          ' `lݒ肪słB
Global Const APCI8815_ERR_TIMER = 5007            ' ^C}lsłB
Global Const APCI8815_ERR_NOT_ENOUGH_MEM = 5008   ' \ȃmۂł܂łB
Global Const APCI8815_ERR_INVALID_FUNC = 5009     ' Ȋ֐ĂяołB
Global Const APCI8815_ERR_NUMDATA = 5010          ' w肳ꂽ̃f[^obt@ɑ݂܂B

Global Const APCI8815_ERR_INTERNAL = 5100         ' Send mail to us
Global Const APCI8815_ERR_UNKNOWN = 5101          ' Help me!
Global Const APCI8815_SUCCESS = 0                 ' Successfully proccessed

Global Const APCI8815_ERR_RESOURCE = 5011         ' Resource exhaustion
Global Const APCI8815_ERR_START = 5012            ' X^[gɎs܂B


'-----------------------------------------------------------
' Resource infomation structure
'-----------------------------------------------------------

Global Const APCI8815_MAX_MEM = 9        ' number of memory windows
Global Const APCI8815_MAX_IO = 20        ' number of i/o windows
Global Const APCI8815_MAX_IRQ = 7        ' number of irqs
Global Const APCI8815_MAX_DMA = 7        ' number of dmas

Type APCI8815RESOURCE
    dwNumMemWindows As Long                          ' Not used
    dwMemBase(1 To APCI8815_MAX_MEM) As Long         ' Not used
    dwMemLength(1 To APCI8815_MAX_MEM) As Long       ' Not used
    dwMemAttrib(1 To APCI8815_MAX_MEM) As Long       ' Not used
    dwNumIOPorts As Long                             ' Num IO ports
    dwIOPortBase(1 To APCI8815_MAX_IO) As Long       ' I/O port base
    dwIOPortLength(1 To APCI8815_MAX_IO) As Long     ' I/O port length
    dwNumIRQs As Long                                ' Num IRQ info
    dwIRQRegisters(1 To APCI8815_MAX_IRQ) As Long    ' IRQ list
    dwIRQAttrib(1 To APCI8815_MAX_IRQ) As Long       ' IRQ Attrib list
    dwNumDMAs As Long                                ' Not used
    dwDMALst(1 To APCI8815_MAX_DMA) As Long          ' Not used
    dwDMAAttrib(1 To APCI8815_MAX_DMA) As Long       ' Not used
    dwReserved1(1 To 3) As Long                      ' Not used
End Type


'-----------------------------------------------------------
' Sampling definition
'-----------------------------------------------------------

' TvO[h
                                  ' Start Sampling Transfer CLK   Message offset
Global Const APCI8815_MODE_01 = 1 ' soft  single   port     ---   WM_EOC
Global Const APCI8815_MODE_02 = 2 ' soft  single   port     EXTRG WM_EOC
Global Const APCI8815_MODE_03 = 3 ' soft  burst    port     timer WM_BUFF_HALF_FULL,BUFF_FULL,
                                  '                               WM_BUFF_OVERFLOW
Global Const APCI8815_MODE_04 = 4 ' soft  burst    port     EXTRG WM_BUFF_HALF_FULL,BUFF_FULL,
                                  '                               WM_BUFF_OVERFLOW

' TvOXe[^X
Global Const APCI8815_STS_SAMPLING = &H1
Global Const APCI8815_STS_EOC = &H2
Global Const APCI8815_STS_BUFF_HALF_FULL = &H4
Global Const APCI8815_STS_BUFF_FULL = &H8
Global Const APCI8815_STS_BUFF_OVERFLOW = &H10
Global Const APCI8815_STS_SAMPLING_OVERRUN = &H20

' Apci8815Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
' ItZbglbZ[Wo܂B
#If WM_EOC Then
#Else
Global Const WM_EOC = 0
Global Const WM_BUFF_HALF_FULL = 1
Global Const WM_BUFF_FULL = 2
Global Const WM_BUFF_OVERFLOW = 3
Global Const WM_SAMPLING_OVERRUN = 4
#End If ' WM_EOC

' `lݒl͈̔
Global Const APCI8815_CH_FIRST = 0
Global Const APCI8815_CH_LAST = 15

' `lݒl
Global Const APCI8815_CH_01 = 0
Global Const APCI8815_CH_02 = 1
Global Const APCI8815_CH_03 = 2
Global Const APCI8815_CH_04 = 3
Global Const APCI8815_CH_05 = 4
Global Const APCI8815_CH_06 = 5
Global Const APCI8815_CH_07 = 6
Global Const APCI8815_CH_08 = 7
Global Const APCI8815_CH_09 = 8
Global Const APCI8815_CH_10 = 9
Global Const APCI8815_CH_11 = 10
Global Const APCI8815_CH_12 = 11
Global Const APCI8815_CH_13 = 12
Global Const APCI8815_CH_14 = 13
Global Const APCI8815_CH_15 = 14
Global Const APCI8815_CH_16 = 15

' ^C}ŏlől
Global Const APCI8815_TM_MIN = 35            ' ݒ肷^C}̍ŏl
Global Const APCI8815_TM_MAX = 64000000      ' ݒ肷^C}̍ől

Type APCI8815MODE
    dwChFirst As Long       ' TvOJn`l(0-15)
    dwChLast As Long        ' TvOI`l(0-15)
                            ' {dwChFirst <= dwChLast}
    cwBuffer As Long        ' obt@TCY
                            ' Oobt@̏ꍇAIɊmۂłlől
    dwTimer As Long         ' ^C}ɃZbgl(1-200e6) [0 = 10sA1 = 20s]
    dwMode As Long          ' 샂[h
End Type

'-----------------------------------------------------------
' API Functions
'-----------------------------------------------------------

Public Declare Function Apci8815GetVersion Lib "apci8815" (ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Long
Public Declare Function Apci8815Create Lib "apci8815" (ByRef pwLogSlot As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Any) As Long
Public Declare Function Apci8815Close Lib "apci8815" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci8815GetResource Lib "apci8815" (ByVal wLogSlot As Integer, ByRef pres As APCI8815RESOURCE) As Long
Public Declare Function Apci8815SetMode Lib "apci8815" (ByVal wLogSlot As Integer, ByRef pcmode As APCI8815MODE) As Long
Public Declare Function Apci8815StartSampling Lib "apci8815" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci8815StopSampling Lib "apci8815" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci8815GetSamplingStatus Lib "apci8815" (ByVal wLogSlot As Integer, ByRef pcwNumData As Long, ByRef pdwStatus As Long) As Long
Public Declare Function Apci8815GetData Lib "apci8815" (ByVal wLogSlot As Integer, ByVal cwNumData As Long, ByRef pwData As Integer) As Long
Public Declare Function Apci8815GetLastError Lib "apci8815" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci8815GetExIn Lib "apci8815" (ByVal wLogSlot As Integer, ByRef pdwExIn0 As Long, ByRef pdwExIn1 As Long, ByRef pdwExTrg As Long) As Long
