Attribute VB_Name = "Sample"
'*****************************************************************************
'* apci8815s.bas                                                             *
'*                                                                           *
'* aPCI-8815                                                             *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/04/21                                                           *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Declare Function GetLastError Lib "kernel32" () As Long

Private Const sz8815 = "aPCI-8815"

Public Sub Main()
    
    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As Long
    Dim bResult As Boolean      ' 
    Dim wLogSlot As Integer     ' foCXi[
    Dim ri As APCI8815RESOURCE  ' \[X
    Dim md As APCI8815MODE      ' TvO[h
    Dim dwNumData As Long
    Dim dwStatus As Long
    Dim wData() As Integer
    Dim i As Long
    Dim dwExIn0 As Long, dwExIn1 As Long, dwExTrg As Long

'---------------------------------------------------------------------------
    ' apci8815.dll ̎gp錾
    If Apci8815wDllOpen() = False Then
        ErrorMessage (APCI8815_SLOT_AUTO)
        Exit Sub                ' apci8815.dll ̃[hɎs܂
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Apci8815wGetVersion(dwDllVer, dwDrvVer) = False Then ' aPCI-8815DLL,Driver̃o[Wԍ擾
        ErrorMessage (APCI8815_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Driver Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aPCI-8815̎gp錾
    wLogSlot = APCI8815_SLOT_AUTO     ' gp̃foCXT܂B
    
    ' ꍇA̎̃foCXi[܂B
    ' EBhEnhȂ̂ 0 Zbg܂B
    ' EBhEnhZbg΁Ae탁bZ[W܂B
    ' 3ԖڂɃZbgẮAbZ[WID̊ƂȂlłB
    ' ۂ̃bZ[WID͂̊lɃItZbg(WM_EOCȂ)̂ƂȂ܂B
    bResult = Apci8815wCreate(wLogSlot, 0, &H6401, 0)
                                             
    If bResult = False Then         ' foCX܂B
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    strbuf = "aPCI-8815 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Apci8815wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + sz8815 + Chr(10) + _
             "IO Base Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1) + Chr(10) + _
             "IRQ: " + Str(ri.dwIRQRegisters(1))

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvO[h̐ݒ
    md.dwChFirst = 0        ' TvOJn`l(0 ` 15)
    md.dwChLast = 15        ' TvOI`l(0 ` 15)
    md.cwBuffer = 256       ' obt@TCYi[hPʁj
    md.dwTimer = 500        ' ^C}l(35`64000000)
    md.dwMode = APCI8815_MODE_03 ' 샂[h(1`4)

    If Apci8815wSetMode(wLogSlot, md) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "aPCI-8815 Sampling Mode" + Chr(10) + _
             "TvOJn`l=" + Str(md.dwChFirst) + Chr(10) + _
             "TvOI`l=" + Str(md.dwChLast) + Chr(10) + _
             "obt@TCY=" + Str(md.cwBuffer) + Chr(10) + _
             "^C}l=" + Str(md.dwTimer) + Chr(10) + _
             "샂[h=" + Str(md.dwMode)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvOJn
    If Apci8815wStartSampling(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aPCI-8815 Sampling Started")

'---------------------------------------------------------------------------
    ' TvOEXe[^X̎擾
    If Apci8815wGetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "TvOEXe[^X擾" + Chr(10) + _
             "f[^=" + Str(dwNumData) + Chr(10) + _
             "Xe[^X=" + Str(dwStatus)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvOς݃f[^̎擾
    If dwNumData > 0 Then
        ReDim wData(1 To dwNumData)
    
        If Apci8815wGetData(wLogSlot, dwNumData, wData) = False Then
            ErrorMessage (wLogSlot)
            Exit Sub
        End If
    
        If dwNumData > 99 Then      ' f[^99ҏW甲悤ɂ
            dwNumData = 99
        End If
    
        strbuf = "TvOς݃f[^擾" + Chr(10)
        For i = 1 To dwNumData
            strbuf = strbuf + Str(i) + ":&H" + Hex(wData(i)) + "  "
    
            If (i + 1) Mod 4 = 0 Then   ' 4 Ŋ؂
                strbuf = strbuf + Chr(10)
            End If
        Next i
    
        ResultMessage (strbuf)
    End If

'---------------------------------------------------------------------------
    ' TvO~
    If Apci8815wStopSampling(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aPCI-8815 Sampling Stopped")

'---------------------------------------------------------------------------
    ' O͏Ԃ̎擾
    If Apci8815wGetExIn(wLogSlot, dwExIn0, dwExIn1, dwExTrg) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "O͏Ԃ̎擾" + Chr(10) + _
             "EXIN0̏=&H" + Hex(dwExIn0) + Chr(10) + _
             "EXIN1̏=&H" + Hex(dwExIn1) + Chr(10) + _
             "EXTRG̏=&H" + Hex(dwExTrg)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aPCI-8815̎gpJ
    If Apci8815wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aPCI-8815 Closed")

'---------------------------------------------------------------------------
    ' apci8815.dll ̎gpJ
    If Apci8815wDllClose() = False Then
        MsgBox "DLL Unload error", vbOKOnly + vbCritical
        Exit Sub        ' apci8815.dll ̃A[hɎs܂B
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)
    
    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub


' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)
    
    Dim dwRes As Long
    Dim szbuf As String
    
    dwRes = Apci8815wGetLastError(wLogSlot)

    Select Case dwRes
    Case APCI8815_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aPCI-8815 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub


