//===================================================================
// Apci8815.h - aPCI-8815 Win-NT4.0/Win 9x DLL Header
// Copyright (c) ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================

#ifndef __INC_APCI8815_H__
#define __INC_APCI8815_H__

#ifdef __cplusplus
extern "C" {
#endif


//-----------------------------------------------------------
// Miscellaneous
//-----------------------------------------------------------

#define APCI8815_MAX_SLOTS		16			// Maximum number of slots

#define APCI8815_SLOT_AUTO		((WORD)~0U) // default search


//-----------------------------------------------------------
//	Device ID
//-----------------------------------------------------------
#define APCI8815_VENDOR_ID				0x136C
#define APCI8815_DEVICE_ID				0x8815

#define Apci8815GetDeviceID		LOWORD(lParam)


//-----------------------------------------------------------
// Error codes
//-----------------------------------------------------------

#define APCI8815_ERR_SYSTEM				5000 // Windows  GetLastError() R[ĂB
											 // ̃tH_ɃhCoȂ\܂B
#define APCI8815_ERR_NO_DEVICE			5001 // gp\ȃfoCX܂B
#define APCI8815_ERR_IN_USE				5002 // w̃foCX͎gpłB
#define APCI8815_ERR_INVALID_ARGUMENT	5003 // Invalid Argument(s)
#define APCI8815_ERR_INVALID_SLOT		5004 // Ș_XbgłB
#define APCI8815_ERR_NOT_CREATED		5005 // foCXNGCgĂ܂B
#define APCI8815_ERR_CHANNEL			5006 // `lݒ肪słB
#define APCI8815_ERR_TIMER				5007 // ^C}lsłB
#define APCI8815_ERR_NOT_ENOUGH_MEM		5008 // \ȃmۂł܂łB
#define APCI8815_ERR_INVALID_FUNC		5009 // Ȋ֐ĂяołB
#define APCI8815_ERR_NUMDATA			5010 // w肳ꂽ̃f[^obt@ɑ݂܂B

#define APCI8815_ERR_INTERNAL			5100 // Send mail to us
#define APCI8815_ERR_UNKNOWN			5101 // Help me!
#define APCI8815_SUCCESS				   0 // Successfully proccessed

#define APCI8815_ERR_RESOURCE			5011 // Resource exhaustion
#define APCI8815_ERR_START				5012 // X^[gɎs܂B


//-----------------------------------------------------------
// Resource infomation structure
//-----------------------------------------------------------

#define APCI8815_MAX_MEM  9			/* number of memory windows */
#define APCI8815_MAX_IO	  20		/* number of i/o windows */
#define APCI8815_MAX_IRQ  7			/* number of irqs */
#define APCI8815_MAX_DMA   7		/* number of dmas */

typedef struct _APCI8815RESOURCE
{
	DWORD	 dwNumMemWindows;						 /* Not used */
	DWORD	 dwMemBase		  [APCI8815_MAX_MEM];	 /* Not used */
	DWORD	 dwMemLength	  [APCI8815_MAX_MEM];	 /* Not used */
	DWORD	 dwMemAttrib	  [APCI8815_MAX_MEM];	 /* Not used */
	DWORD	 dwNumIOPorts;							 /* Num IO ports */
	DWORD	 dwIOPortBase	  [APCI8815_MAX_IO];	 /* I/O port base */
	DWORD	 dwIOPortLength	  [APCI8815_MAX_IO];	 /* I/O port length */
	DWORD	 dwNumIRQs;								 /* Num IRQ info */
	DWORD	 dwIRQRegisters	  [APCI8815_MAX_IRQ];	 /* IRQ list */
	DWORD	 dwIRQAttrib	  [APCI8815_MAX_IRQ];	 /* IRQ Attrib list */
	DWORD	 dwNumDMAs;								 /* Not used */
	DWORD	 dwDMALst		  [APCI8815_MAX_DMA];	 /* Not used */
	DWORD	 dwDMAAttrib	  [APCI8815_MAX_DMA];	 /* Not used */
	DWORD	 dwReserved1	  [3];					 /* Not used */
} APCI8815RESOURCE, *PAPCI8815R;


//-----------------------------------------------------------
// Sampling definition
//-----------------------------------------------------------

// TvO[h
							// Start Sampling Transfer CLK	 Message offset
#define APCI8815_MODE_01  1 // soft	 single	  port	   ---	 WM_EOC
#define APCI8815_MODE_02  2 // soft	 single	  port	   EXTRG WM_EOC
#define APCI8815_MODE_03  3 // soft	 burst	  port	   timer WM_BUFF_HALF_FULL,BUFF_FULL,
							//								 WM_BUFF_OVERFLOW
#define APCI8815_MODE_04  4 // soft	 burst	  port	   EXTRG WM_BUFF_HALF_FULL,BUFF_FULL,
							//								 WM_BUFF_OVERFLOW

// TvOXe[^X
#define APCI8815_STS_SAMPLING			0x01
#define APCI8815_STS_EOC				0x02
#define APCI8815_STS_BUFF_HALF_FULL		0x04
#define APCI8815_STS_BUFF_FULL			0x08
#define APCI8815_STS_BUFF_OVERFLOW		0x10
#define APCI8815_STS_SAMPLING_OVERRUN	0x20

// Apci8815Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
// ItZbglbZ[Wo܂B
#ifndef WM_EOC
#define WM_EOC							0
#define WM_BUFF_HALF_FULL				1
#define WM_BUFF_FULL					2
#define WM_BUFF_OVERFLOW				3
#define WM_SAMPLING_OVERRUN				4
#endif // WM_EOC

// `lݒl͈̔
#define APCI8815_CH_FIRST	0
#define APCI8815_CH_LAST	15

// `lݒl
#define APCI8815_CH_01		0
#define APCI8815_CH_02		1
#define APCI8815_CH_03		2
#define APCI8815_CH_04		3
#define APCI8815_CH_05		4
#define APCI8815_CH_06		5
#define APCI8815_CH_07		6
#define APCI8815_CH_08		7
#define APCI8815_CH_09		8
#define APCI8815_CH_10		9
#define APCI8815_CH_11		10
#define APCI8815_CH_12		11
#define APCI8815_CH_13		12
#define APCI8815_CH_14		13
#define APCI8815_CH_15		14
#define APCI8815_CH_16		15

// ^C}ŏlől
#define APCI8815_TM_MIN		35			// ݒ肷^C}̍ŏl
#define APCI8815_TM_MAX		64000000	// ݒ肷^C}̍ől

typedef struct _APCI8815MODE
{
	DWORD dwChFirst;		// TvOJn`l(0-15)
	DWORD dwChLast;			// TvOI`l(0-15)
							// {dwChFirst <= dwChLast}
	DWORD cwBuffer;			// obt@TCY
							// Oobt@̏ꍇAIɊmۂłlől
	DWORD dwTimer;			// ^C}ɃZbgl(1-200e6) [0 = 10sA1 = 20s]
	DWORD dwMode;			// 샂[h
} APCI8815MODE;

typedef CONST APCI8815MODE *PCAPCI8815M;

//-----------------------------------------------------------
// API Functions
//-----------------------------------------------------------

#if !defined( APCI8815_DRIVER )

#if !defined( APCI8815_DLL )
	#define APCI8815_API __declspec(dllimport)
#else
	#define APCI8815_API
#endif

APCI8815_API BOOL	WINAPI Apci8815GetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer);
APCI8815_API BOOL	WINAPI Apci8815Create(PWORD pwLogSlot, HWND hWnd, UINT uWMBase, PVOID pvInitArg);
APCI8815_API BOOL	WINAPI Apci8815Close(WORD wLogSlot);
APCI8815_API BOOL	WINAPI Apci8815GetResource(WORD wLogSlot, PAPCI8815R pres);
APCI8815_API BOOL	WINAPI Apci8815SetMode(WORD wLogSlot, PCAPCI8815M pcmode);
APCI8815_API BOOL	WINAPI Apci8815StartSampling(WORD wLogSlot);
APCI8815_API BOOL	WINAPI Apci8815StopSampling(WORD wLogSlot);
APCI8815_API BOOL	WINAPI Apci8815GetSamplingStatus(WORD wLogSlot, PDWORD pcwNumData, PDWORD pdwStatus);
APCI8815_API BOOL	WINAPI Apci8815GetData(WORD wLogSlot, DWORD cwNumData, PWORD pwData);
APCI8815_API DWORD	WINAPI Apci8815GetLastError(WORD wLogSlot);
APCI8815_API BOOL	WINAPI Apci8815GetExIn(WORD wLogSlot, PDWORD pdwExIn0, PDWORD pdwExIn1, PDWORD pdwExTrg);

#endif	// APCI8815_DRIVER


#ifdef __cplusplus
}
#endif

#endif __INC_APCI8815_H__
