/******************************************************************************/
/*	apci8815s.c																  */
/*																			  */
/*	aPCI-8815															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1998/07/10															  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include	<windows.h>
#include	<tchar.h>

#include "apci8815w.h"


const TCHAR szTitle[] = _T("Sample");
const TCHAR sz8815[]  = _T("aPCI-8815");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[1024], szTmp[20];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// foCXi[
	APCI8815RESOURCE ri;			// \[X
	APCI8815MODE	 md;			// TvO[h
	DWORD dwNumData;
	DWORD dwStatus;
	PWORD pwData;
	LONG  i;
	DWORD dwExIn0, dwExIn1, dwExTrg;

/*---------------------------------------------------------------------------*/
	// apci8815.dll ̎gp錾
	if (Apci8815wDllOpen() == FALSE)
	{
		ErrorMessage(APCI8815_SLOT_AUTO);
		return 1;			// apci8815.dll ̃[hɎs܂
	}

/*---------------------------------------------------------------------------*/
	// o[Wԍ\
	// aPCI-8815 DLL,Driver̃o[Wԍ擾
	if (Apci8815wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE)
	{
		ErrorMessage(APCI8815_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("Drv Version: %08lxh"),
					dwDLLVer,
					dwDrvVer);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aPCI-8815̎gp錾
	wLogSlot = APCI8815_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Apci8815wCreate(&wLogSlot,	// ꍇA̎̃foCXi[܂B
							NULL,		// EBhEnhȂ̂NULLZbg܂B
										// EBhEnhZbg΁A
										// e탁bZ[W܂B
							0x6401,		// 3ԖڂɃZbgẮAbZ[WID̊
										// ƂȂlłBۂ̃bZ[WID͂̊lɃI
										// tZbg(WM_EOCȂ)̂ƂȂ܂B
							NULL);

	if (bResult == FALSE)		// foCX܂B
	{
		ErrorMessage(APCI8815_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("aPCI-8815 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// \[X擾
	if (Apci8815wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("Board Name: %s\n")
					_T("IO Base Address: %04xh-%04x\n")
					_T("IRQ: %2d\n"),
					sz8815,
					ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1,
					ri.dwIRQRegisters[0]);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvO[h̐ݒ
	md.dwChFirst = 0;		// TvOJn`l(0 ` 15)
	md.dwChLast	= 15;		// TvOI`l(0 ` 15)
	md.cwBuffer = 256;		// obt@TCYi[hPʁj
	md.dwTimer	= 500;		// ^C}l(35`64000000)
	md.dwMode	= APCI8815_MODE_03;	// 샂[h(1`4)

	if (Apci8815wSetMode(wLogSlot, &md) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("aPCI-8815 Sampling Mode\n")
					_T("TvOJn`l=%ld\n")
					_T("TvOI`l=%ld\n")
					_T("obt@TCY=%ld\n")
					_T("^C}l=%ld\n")
					_T("샂[h=%ld"),
					md.dwChFirst, md.dwChLast, md.cwBuffer, md.dwTimer, md.dwMode);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvOJn
	if (Apci8815wStartSampling(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aPCI-8815 Sampling Started"));

/*---------------------------------------------------------------------------*/
	// TvOEXe[^X̎擾
	if (Apci8815wGetSamplingStatus(wLogSlot, &dwNumData, &dwStatus) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("TvOEXe[^X擾\n")
					_T("f[^=%ld\n")
					_T("Xe[^X=%ld"),
					dwNumData, dwStatus);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvOς݃f[^̎擾
	if (dwNumData)
	{
		pwData = (PWORD)malloc(dwNumData * sizeof(WORD));
		memset(pwData, 0, dwNumData * sizeof(WORD));

		if (Apci8815wGetData(wLogSlot, dwNumData, pwData) == FALSE)
		{
			ErrorMessage(wLogSlot);
			return 1;
		}

		wsprintf(szbuf, _T("TvOς݃f[^擾\n"));
		for (i = 0; i < (LONG)dwNumData && lstrlen(szbuf) < sizeof(szbuf) - sizeof(szTmp) ; i++)
		{
			wsprintf(szTmp, _T("%ld:%lxh  "), i, pwData[i]);

			strcat(szbuf, szTmp);

			if ((i + 1) % 4 == 0)	// 4 Ŋ؂
				strcat(szbuf, _T("\n"));
		}

		ResultMessage(szbuf);

		free(pwData);
	}

/*---------------------------------------------------------------------------*/
	// TvO~
	if (Apci8815wStopSampling(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aPCI-8815 Sampling Stopped"));

/*---------------------------------------------------------------------------*/
	// O͏Ԃ̎擾
	if (Apci8815wGetExIn(wLogSlot, &dwExIn0, &dwExIn1, &dwExTrg) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("O͏Ԃ̎擾\n")
					_T("EXIN0̏=%lxh\n")
					_T("EXIN1̏=%lxh\n")
					_T("EXTRG̏=%lxh"),
					dwExIn0, dwExIn1, dwExTrg);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aPCI-8815̎gpJ
	if (Apci8815wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aPCI-8815 Closed"));

/*---------------------------------------------------------------------------*/
	// apci8815.dll ̎gpJ
	if (Apci8815wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL Unload error"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// apci8815.dll ̃A[hɎs܂B
	}

	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Apci8815wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes)
	{
		case APCI8815_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aPCI-8815 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
