/*****************************************************************************/
/*	apci8815w.c																 */
/*																			 */
/*	aPCI-8815															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1998/07/10															 */
/*																			 */
/*****************************************************************************/

#define STRICT

#include <windows.h>
#include <tchar.h>

#include "apci8815w.h"	// aPCI-8815

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Apci8815wGetDllExportFunc();

/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[ϐ
static FARPROC pApci8815GetVersion;
static FARPROC pApci8815Create;
static FARPROC pApci8815Close;
static FARPROC pApci8815GetResource;
static FARPROC pApci8815SetMode;
static FARPROC pApci8815StartSampling;
static FARPROC pApci8815StopSampling;
static FARPROC pApci8815GetSamplingStatus;
static FARPROC pApci8815GetData;
static FARPROC pApci8815GetExIn;
static FARPROC pApci8815GetLastError;


/*****************************************************************************/
/* 	  apci8815.dll[h												 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(APCI8815_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Apci8815wGetDllExportFunc() == FALSE)
	{
		Apci8815wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  apci8815.dllA[h											 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

/*****************************************************************************/
/* 	  aPCI-8815 DLL,Driver̃o[Wԍ擾							 */
/* 	  pdwDllVer DLLo[Wԍi[AhX						 */
/*		  pdwDrvVer Drivero[Wԍi[AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8815GetVersion)(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aPCI-8815̔Cӂ̃foCX̎gp錾								 */
/* 	  pwLogSlot gpfoCXi[AhX						 */
/*		  hWnd		bZ[W𑗂EBhEnh						 */
/*		  uWMBase	ƂȂ郁bZ[WID									 */
/*		  pvInitArg gp(NULLZbg)									 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wCreate(PWORD pwLogSlot, HWND hWnd, UINT uWMBase, PVOID pvInitArg)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8815Create)(pwLogSlot, hWnd, uWMBase, pvInitArg);
}

/*****************************************************************************/
/* 	  aPCI-8815̔Cӂ̃foCX̎gpJ								 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8815Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot ׂfoCX											 */
/*		  pres	   \[Xi[\̂̃AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wGetResource(WORD wLogSlot, PAPCI8815R pres)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8815GetResource)(wLogSlot, pres);
}

/*****************************************************************************/
/* 	  TvO[h̐ݒ											 */
/* 	  wLogSlot ݒ肷foCX											 */
/*		  pcmode   [hݒf[^̃AhX								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wSetMode(WORD wLogSlot, PCAPCI8815M pcmode)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8815SetMode)(wLogSlot, pcmode);
}

/*****************************************************************************/
/* 	  TvOJn													 */
/* 	  wLogSlot JnfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wStartSampling(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8815StartSampling)(wLogSlot);
}

/*****************************************************************************/
/* 	  TvO~													 */
/* 	  wLogSlot ~foCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wStopSampling(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8815StopSampling)(wLogSlot);
}

/*****************************************************************************/
/* 	  TvOEXe[^X̎擾									 */
/* 	  wLogSlot	 擾foCX										 */
/*		  pcwNumData f[^obt@AhX								 */
/*		  pdwStatus	 Xe[^XAhX										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wGetSamplingStatus(WORD wLogSlot, PDWORD pcwNumData, PDWORD pdwStatus)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8815GetSamplingStatus)(wLogSlot, pcwNumData, pdwStatus);
}

/*****************************************************************************/
/* 	  TvOς݃f[^̎擾										 */
/* 	  wLogSlot	擾foCX										 */
/*		  cwNumData vf[^											 */
/*		  pwData	f[^obt@ւ̃AhX								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wGetData(WORD wLogSlot, DWORD cwNumData, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8815GetData)(wLogSlot, cwNumData, pwData);
}

/*****************************************************************************/
/* 	  aPCI-8815̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Apci8815wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return APCI8815_ERR_WRAPDLL;

	return (*pApci8815GetLastError)(wLogSlot);
}

/*****************************************************************************/
/* 	  O͏Ԃ̎擾												 */
/* 	  wLogSlot 擾foCX											 */
/*		  pdwExIn0 EXIN0̏												 */
/*		  pdwExIn1 EXIN1̏												 */
/*		  pdwExTrg EXTRG̏												 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci8815wGetExIn(WORD wLogSlot, PDWORD pdwExIn0, PDWORD pdwExIn1, PDWORD pdwExTrg)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci8815GetExIn)(wLogSlot, pdwExIn0, pdwExIn1, pdwExTrg);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Apci8815wGetDllExportFunc()
{
	// Apci8815GetVersion ̃AhX擾
	pApci8815GetVersion = GetProcAddress(hDLL, _T("Apci8815GetVersion"));
	if (pApci8815GetVersion == NULL)
		return FALSE;

	// Apci8815Create ̃AhX擾
	pApci8815Create = GetProcAddress(hDLL, _T("Apci8815Create"));
	if (pApci8815Create == NULL)
		return FALSE;

	// Apci8815Close ̃AhX擾
	pApci8815Close = GetProcAddress(hDLL, _T("Apci8815Close"));
	if (pApci8815Close == NULL)
		return FALSE;

	// Apci8815GetResource ̃AhX擾
	pApci8815GetResource = GetProcAddress(hDLL, _T("Apci8815GetResource"));
	if (pApci8815GetResource == NULL)
		return FALSE;

	// Apci8815SetMode ̃AhX擾
	pApci8815SetMode = GetProcAddress(hDLL, _T("Apci8815SetMode"));
	if (pApci8815SetMode == NULL)
		return FALSE;

	// Apci8815StartSampling ̃AhX擾
	pApci8815StartSampling = GetProcAddress(hDLL, _T("Apci8815StartSampling"));
	if (pApci8815StartSampling == NULL)
		return FALSE;

	// Apci8815StopSampling ̃AhX擾
	pApci8815StopSampling = GetProcAddress(hDLL, _T("Apci8815StopSampling"));
	if (pApci8815StopSampling == NULL)
		return FALSE;

	// Apci8815GetSamplingStatus ̃AhX擾
	pApci8815GetSamplingStatus = GetProcAddress(hDLL, _T("Apci8815GetSamplingStatus"));
	if (pApci8815GetSamplingStatus == NULL)
		return FALSE;

	// Apci8815GetData ̃AhX擾
	pApci8815GetData = GetProcAddress(hDLL, _T("Apci8815GetData"));
	if (pApci8815GetData == NULL)
		return FALSE;

	// Apci8815GetLastError ̃AhX擾
	pApci8815GetLastError = GetProcAddress(hDLL, _T("Apci8815GetLastError"));
	if (pApci8815GetLastError == NULL)
		return FALSE;

	// Apci8815GetExIn ̃AhX擾
	pApci8815GetExIn = GetProcAddress(hDLL, _T("Apci8815GetExIn"));
	if (pApci8815GetExIn == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
